FROM golang:1.22 as build-stage

# Set destination for COPY
WORKDIR /app

# Download Go modules
COPY go.mod go.sum ./
RUN go mod download

# Copy the source code. Note the slash at the end, as explained in
# https://docs.docker.com/reference/dockerfile/#copy
COPY . ./

RUN ls
# Build
RUN CGO_ENABLED=0 GOOS=linux go build -o /shrt ./cmd/main.go

# Optional:
# To bind to a TCP port, runtime parameters must be supplied to the docker command.
# But we can document in the Dockerfile what ports
# the application is going to listen on by default.
# https://docs.docker.com/reference/dockerfile/#expose
EXPOSE 8090

FROM gcr.io/distroless/base-debian11 AS build-release-stage

WORKDIR /

COPY --from=build-stage /shrt /shrt
COPY --from=build-stage /app/public /public

EXPOSE 8090

USER nonroot:nonroot

ENTRYPOINT ["/shrt"]
